#property copyright "SIGLOT"
#property link      "siglot.com"

#property indicator_separate_window
#property indicator_minimum 0.0
#property indicator_maximum 2.0
#property indicator_buffers 3
#property indicator_color1 Red
#property indicator_color2 Lime
#property indicator_color3 White

extern int FastLen = 4; // default 144
extern int SlowLen = 12; // default 233
extern int SMA = 7; // default 50
extern bool UseAlert = FALSE;
extern int AlertIterations = 1;
extern int AlertInterval = 1;
extern bool GreenRedAlertsEmail = FALSE;
extern bool YellowAlertsEmail = FALSE;
extern string LinesIdentifier = "MacdLines1";
extern color LinesColorForUp = SteelBlue;
extern color LinesColorForDown = Red;
extern int LinesStyle = 0;
double G_ibuf_128[];
double G_ibuf_132[];
double G_ibuf_136[];
int G_bars_140;
int Gi_144;
bool Gi_148;
bool Gi_152 = FALSE;
bool Gi_156 = FALSE;
bool Gi_160 = FALSE;
int G_second_164;

int init() {
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0, 110);
   SetIndexBuffer(0, G_ibuf_128);
   SetIndexEmptyValue(0, EMPTY_VALUE);
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexArrow(1, 110);
   SetIndexBuffer(1, G_ibuf_132);
   SetIndexEmptyValue(1, EMPTY_VALUE);
   SetIndexStyle(2, DRAW_ARROW);
   SetIndexArrow(2, 110);
   SetIndexBuffer(2, G_ibuf_136);
   SetIndexEmptyValue(2, EMPTY_VALUE);
   return (0);
}

int deinit() {
   string name_8;
   int str_len_0 = StringLen(LinesIdentifier);
   for (int objs_total_4 = ObjectsTotal(); objs_total_4 >= 0; objs_total_4--) {
      name_8 = ObjectName(objs_total_4);
      if (StringSubstr(name_8, 0, str_len_0) == LinesIdentifier) ObjectDelete(name_8);
   }
   return (0);
}

int start() {
   double Ld_12;
   double Ld_20;
   double Ld_28;
   double Ld_36;
   int Li_4 = IndicatorCounted();
   if (Li_4 < 0) return (-1);
   if (Li_4 > 0) Li_4--;
   int Li_0 = Bars - Li_4;
   for (int Li_8 = Li_0; Li_8 >= 0; Li_8--) {
      Ld_12 = (High[Li_8] + Low[Li_8] + Close[Li_8]) / 3.0;
      Ld_20 = Ld_12 - iMA(NULL, 0, SMA, 0, MODE_SMA, PRICE_TYPICAL, Li_8);
      Ld_28 = iMA(NULL, 0, FastLen, 0, MODE_EMA, PRICE_CLOSE, Li_8) - iMA(NULL, 0, SlowLen, 0, MODE_EMA, PRICE_CLOSE, Li_8);
      Ld_36 = iMA(NULL, 0, FastLen, 0, MODE_EMA, PRICE_CLOSE, Li_8 + 1) - iMA(NULL, 0, SlowLen, 0, MODE_EMA, PRICE_CLOSE, Li_8 + 1);
      G_ibuf_128[Li_8] = EMPTY_VALUE;
      G_ibuf_132[Li_8] = EMPTY_VALUE;
      G_ibuf_136[Li_8] = EMPTY_VALUE;
      if (Ld_20 > 0.0 && Ld_28 > Ld_36) G_ibuf_128[Li_8] = 1;
      else {
         if (Ld_20 < 0.0 && Ld_28 < Ld_36) G_ibuf_132[Li_8] = 1;
         else G_ibuf_136[Li_8] = 1;
      }
      f0_1(Li_8);
      if (G_ibuf_136[Li_8 + 1] == 1.0 && G_ibuf_136[Li_8] != 1.0) {
         if (G_ibuf_128[Li_8] == 1.0) {
            f0_0(Li_8, LinesColorForUp);
            continue;
         }
         f0_0(Li_8, LinesColorForDown);
      }
   }
   if (UseAlert == TRUE) {
      if (G_ibuf_128[1] != EMPTY_VALUE && G_ibuf_128[2] == EMPTY_VALUE && G_ibuf_132[1] == EMPTY_VALUE && G_ibuf_136[1] == EMPTY_VALUE && Bars != G_bars_140 && Seconds() < 5) {
         Alert("", Symbol(), " (", Period(), ")  Trend Buy\n");
         Gi_144 = AlertIterations - 1;
         Gi_148 = TRUE;
         G_second_164 = Seconds();
         Gi_152 = TRUE;
         if (GreenRedAlertsEmail == TRUE) SendMail("From Metatrader\'s MACD SMA", "The MACD SMA at " + Symbol() + " (" + Period() + ") Trend Buy");
      }
      if (G_ibuf_128[1] == EMPTY_VALUE && G_ibuf_132[1] != EMPTY_VALUE && G_ibuf_132[2] == EMPTY_VALUE && G_ibuf_136[1] == EMPTY_VALUE && Bars != G_bars_140 && Seconds() < 5) {
         Alert("", Symbol(), " (", Period(), ") Trend Sell\n");
         Gi_144 = AlertIterations - 1;
         Gi_148 = TRUE;
         G_second_164 = Seconds();
         Gi_160 = TRUE;
         if (GreenRedAlertsEmail == TRUE) SendMail("From Metatrader\'s MACD SMA", "The MACD SMA at " + Symbol() + " (" + Period() + ")Trend Sell");
      }
      if (G_ibuf_128[1] == EMPTY_VALUE && G_ibuf_132[1] == EMPTY_VALUE && G_ibuf_136[1] != EMPTY_VALUE && G_ibuf_136[2] == EMPTY_VALUE && Bars != G_bars_140 && Seconds() < 5) {
         Alert("", Symbol(), " (", Period(), ") Watch for Trend Change\n");
         Gi_144 = AlertIterations - 1;
         Gi_148 = TRUE;
         G_second_164 = Seconds();
         Gi_156 = TRUE;
         if (YellowAlertsEmail == TRUE) SendMail("From Metatrader\'s MACD SMA", "The MACD SMA at " + Symbol() + " (" + Period() + ") No Trend");
      }
      if (Seconds() > G_second_164 + AlertInterval && Gi_152 == TRUE && Gi_144 > 0 && Gi_148 == TRUE) {
         Alert("MACD SMA is now green @ ", Symbol(), " (", Period(), ")\n");
         Gi_144--;
         G_second_164 = Seconds();
      }
      if (Seconds() > G_second_164 + AlertInterval && Gi_156 == TRUE && Gi_144 > 0 && Gi_148 == TRUE) {
         Alert("MACD SMA is now yellow @ ", Symbol(), " (", Period(), ")\n");
         Gi_144--;
         G_second_164 = Seconds();
      }
      if (Seconds() > G_second_164 + AlertInterval && Gi_160 == TRUE && Gi_144 > 0 && Gi_148 == TRUE) {
         Alert("MADC SMA is now red @ ", Symbol(), " (", Period(), ")\n");
         Gi_144--;
         G_second_164 = Seconds();
      }
      G_bars_140 = Bars;
   }
   return (0);
}

void f0_1(int Ai_0) {
   ObjectDelete(LinesIdentifier + ":" + Time[Ai_0]);
}

void f0_0(int Ai_0, color A_color_4) {
   string name_8 = LinesIdentifier + ":" + Time[Ai_0];
   if (ObjectFind(name_8) < 0) ObjectCreate(name_8, OBJ_VLINE, 0, Time[Ai_0], 0);
   ObjectSet(name_8, OBJPROP_COLOR, A_color_4);
   ObjectSet(name_8, OBJPROP_BACK, TRUE);
   ObjectSet(name_8, OBJPROP_STYLE, LinesStyle);
}
